#!/usr/bin/perl -w

use strict;
use warnings FATAL => 'all';

use BerkeleyDB;

my %users;
my %ninetofive;

my $env = new BerkeleyDB::Env
        -Home   => '/etc/raddb/state',
        -Flags  => DB_CREATE| DB_INIT_CDB | DB_INIT_MPOOL
or die "cannot open environment: $BerkeleyDB::Error";

tie %users, "BerkeleyDB::Hash",
        -Filename       => 'users.db',
        -Flags          => DB_CREATE,
        -Env            => $env
or die "cannot open database: $BerkeleyDB::Error";

tie %ninetofive, "BerkeleyDB::Hash",
        -Filename       => 'ninetofive.db',
        -Flags          => DB_CREATE,
        -Env            => $env
or die "cannot open database: $BerkeleyDB::Error";

my %users_from_file;
my %ninetofive_from_file;

if (@ARGV != 2) {
        die("Syntax: $0 </path/to/smsotp_users.txt> </path/to/smsotp_ninetofive.txt>");
}

open(USERS, '<', $ARGV[0]) || die ("Can't open $ARGV[0] for reading: $!");
open(NINETOFIVE, '<', $ARGV[1]) || die ("Can't open $ARGV[1] for reading: $!");

while (<USERS>) {
        next if /^\s*$/;
        next if /^#/;
        my ($user, $mobile) = split;
        $users_from_file{lc($user)} = $mobile;
}

while (<NINETOFIVE>) {
        next if /^\s*$/;
        next if /^#/;
        my ($user, $mobile) = split;
        $ninetofive_from_file{lc($user)} = 1;
}

%users = %users_from_file;
%ninetofive = %ninetofive_from_file;
